/* 2lf, Copyright(c) 1996, 1998
 * by Eddie Buckley <eddie@sjfn.nb.ca>
 *
 * Permission to use, copy, modify, distribute, and sell this software and its
 * documentation for any purpose is hereby granted without fee, provided that
 * the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation.  No representations are made about the suitability of this
 * software for any purpose.  It is provided "as is" without express or 
 * implied warranty.
 */

#include <stdlib.h>
#include <stdio.h>
#include "strp.h"

const	char	*arg_chars = "hnv";
const	char	*usage_chars = "[-h|-n|-v]";

int
no_dup(char curr, char last, char *buff, int posn)
{
	static	int	status = 0;
	static	char	obj = -1;

	if(obj == -1)  obj = last;

	if((curr == obj) && (status == 1))  {
		status = 0;
		return(posn);
	}
	else if(curr != obj)
		*(buff+posn) = curr;
	else if((curr == obj) && (status == 0))  {
		*(buff+posn) = curr;
		status = 1;
	}
	return(++posn);
}

void
help(void)
{
    printf("Eliminate duplicate line breaks in FILE(s), or standard input to standard "
           "\n output.\n");
    printf("\t-h\tshow this help and version number\n");
    printf("\t-n\teliminate duplicate line feeds\n");
    printf("\t-v\tprint version number and exit\n");
    printf("\nIf more than one command line option is present only the first "
           "one is used.\n");
    printf("\nWith no FILE or when FILE is - read from standard input and "
           "write to standard\n output.\n\n");
}

void
ver(void)
{
    printf("%s%s%s%s", "2lf version ", VERSION, " Copyright(c) 1996, 1998 by ",
           "Eddie Buckley <eddie@sjfn.nb.ca>\n");
}

char
arg_parse(char arg)
{
    switch(arg)
    {
        case 'h':
            ver();
            usage();
            help();
            exit(0);
            break;
        case 'n':
            func_p = no_dup;
            break;
        case 'v':
            ver();
            exit(0);
            break;
    }
    return '\n';
}

